"use strict";
var Event = (function () {
    function Event() {
    }
    return Event;
}());
exports.Event = Event;
var Command = (function () {
    function Command() {
    }
    return Command;
}());
exports.Command = Command;
var EventListener = (function () {
    function EventListener() {
    }
    return EventListener;
}());
exports.EventListener = EventListener;
var CommandHandler = (function () {
    function CommandHandler() {
    }
    return CommandHandler;
}());
exports.CommandHandler = CommandHandler;
var Cqrs = (function () {
    function Cqrs() {
        this.verbose = false;
        this.commandHandlers = new Array();
        this.eventListeners = new Array();
    }
    Object.defineProperty(Cqrs, "Instance", {
        get: function () {
            return this._instance || (this._instance = new this());
        },
        enumerable: true,
        configurable: true
    });
    Cqrs.prototype.AddCommandHandler = function (command, commandHandler, context) {
        if (this.verbose)
            console.log("Registered command handler " + commandHandler.name + " for command " + command.name);
        this.commandHandlers[command.name] = { handler: commandHandler, context: context };
    };
    Cqrs.prototype.AddEventListener = function (event, eventListener, context) {
        var eventName = event.name;
        if (this.verbose)
            console.log("Registered event listener " + eventListener.name + " for event " + eventName);
        if (!this.eventListeners[eventName]) {
            this.eventListeners[eventName] = new Array();
        }
        this.eventListeners[eventName].push({ listener: eventListener, context: context });
    };
    Cqrs.prototype.RemoveCommandHandler = function (command) {
        if (this.verbose)
            console.log("Removed command handler for command " + command.name);
        this.commandHandlers[command.name] = null;
    };
    Cqrs.prototype.RemoveEventListener = function (event, eventListener) {
        var eventName = event.name;
        if (this.verbose)
            console.log("Removed event listener " + eventListener.name + " for event " + eventName);
        var specificEventListeners = this.eventListeners[eventName];
        if (specificEventListeners) {
            for (var i = specificEventListeners.length - 1; i >= 0; i--) {
                if (specificEventListeners[i].listener === eventListener) {
                    specificEventListeners.splice(i, 1);
                }
            }
        }
    };
    Cqrs.prototype.Send = function (command) {
        if (this.verbose)
            console.log("Sent command " + command.constructor.name + " /**/", command);
        if (!this.commandHandlers[command.constructor.name]) {
            throw "Command " + command.constructor.name + " has no handler.";
        }
        var commandHandlerType = this.commandHandlers[command.constructor.name];
        var commandHandler = new commandHandlerType.handler();
        return commandHandler.handle(command, commandHandlerType.context);
    };
    Cqrs.prototype.Publish = function (event) {
        if (this.verbose)
            console.log("Published event " + event.constructor.name + " /**/", event);
        if (!this.eventListeners[event.constructor.name])
            return;
        this.eventListeners[event.constructor.name].forEach(function (eventListenerContainer) {
            var eventListener = new eventListenerContainer.listener();
            eventListener.handle(event, eventListenerContainer.context);
        });
    };
    return Cqrs;
}());
exports.Cqrs = Cqrs;
;
//# sourceMappingURL=index.js.map